#include <cstdlib>

#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLGENBUFFERSPROC glGenBuffers;
PFNGLISBUFFERPROC glIsBuffer;
PFNGLBINDBUFFERPROC glBindBuffer;
PFNGLBUFFERDATAPROC glBufferData;
PFNGLBUFFERSUBDATAPROC glBufferSubData;
PFNGLMAPBUFFERPROC glMapBuffer;
PFNGLUNMAPBUFFERPROC glUnmapBuffer;
PFNGLDELETEBUFFERSPROC glDeleteBuffers;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/*
** gbN{[p֐̐錾
*/
#include "trackball.h"

/*
** `f[^
*/
#include "Obj.h"
Obj *data;

/*
** _̋
*/
static double offset = -200.0;

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 };  /* ʒu */

/*
** 
*/
static void init(void)
{
#if defined(WIN32)
  glGenBuffers =
    (PFNGLGENBUFFERSPROC)wglGetProcAddress("glGenBuffers");
  glIsBuffer =
    (PFNGLISBUFFERPROC)wglGetProcAddress("glIsBuffer");
  glBindBuffer =
    (PFNGLBINDBUFFERPROC)wglGetProcAddress("glBindBuffer");
  glBufferData =
    (PFNGLBUFFERDATAPROC)wglGetProcAddress("glBufferData");
  glBufferSubData =
    (PFNGLBUFFERSUBDATAPROC)wglGetProcAddress("glBufferSubData");
  glMapBuffer =
    (PFNGLMAPBUFFERPROC)wglGetProcAddress("glMapBuffer");
  glUnmapBuffer =
    (PFNGLUNMAPBUFFERPROC)wglGetProcAddress("glUnmapBuffer");
  glDeleteBuffers =
    (PFNGLDELETEBUFFERSPROC)wglGetProcAddress("glDeleteBuffers");
#endif

  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);

  /* `f[^IuWFNg̍쐬 */
  data = new Obj("bunny.obj");
}

/*
** V[̕`
*/
void scene(void)
{
  data->draw();
}

/****************************
** GLUT ̃R[obN֐ **
****************************/

static void display(void)
{
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, offset);
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
  
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* V[̕` */
  scene();
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* gbN{[͈ */
  trackballRegion(w, h);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, w, h);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  
  /* ϊs̏ */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 500.0);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      glutIdleFunc(0);
      trackballStop(x, y);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case '+':
    offset += 10.0;
    glutPostRedisplay();
    break;
  case '-':
    offset -= 10.0;
    glutPostRedisplay();
    break;
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
